%ifnos darwin
%define __cp_a          cp -a
%define __defattr       %defattr(-,root,root)
%define __soext         so
%else
%define __cp_a          cp -pPR
%define __defattr       %defattr(-,root,wheel)
%define __soext         dylib
%endif
%define __kpsver        3.4.4
%define __kpslib        libkpathsea.%{__soext}.%{__kpsver}

%define texmf		%{_datadir}/texmf
%define build_texmf	%{buildroot}%{texmf}
%ifnos darwin
%define exec_texhash	[ -x %{_bindir}/texhash ] && %{_bindir}/env - %{_bindir}/texhash 2> /dev/null
%else
%define exec_texhash	[ -x %{_bindir}/texhash ] && (PATH=$PATH:%{_bindir}; %{_bindir}/texhash) 2> /dev/null
%endif

Summary: Dvi viewer
Summary(ja): DVI եΥץӥ塼
Name: xdvik
%define eversion 22.40w
%define jversion j1.17
Version: %{eversion}_jp
Release: 0vl1b
Source0: http://telia.dl.sourceforge.net/sourceforge/xdvi/xdvik-%{eversion}.tar.gz
Source1: XDvi.vine.ad
Source2: vfontmap.vine.add3
Patch0: http://www.nn.iij4u.or.jp/~tutimura/tex/xdvik-%{eversion}-%{jversion}.patch.gz
# patches for Vine Linux
Patch1: xdvik.xdvi.vine.diff
Patch2: xdvik-config.vine.diff
Patch12: teTeX-src-beta-20020530.oxdvi.patch
Patch13: xdvik-config.macosx.diff
Patch14: xdvik-22.40w-macosx.patch

Copyright: GPL
Group: Applications/Publishing
%ifnos darwin
Requires: VFlib >= 2.24, tetex
%else
Requires: VFlib2 >= 2.24, tetex
%endif
BuildRequires: Xaw3d-devel
BuildRequires: tetex >= 2.0
Prereq: tetex >= 2.0
Provides: tetex-xdvik %{__kpslib}
Buildroot: %{_tmppath}/%{name}-root

%ifnos darwin
Vendor: Project Vine
Distribution: Vine Linux
%endif

%description
This software is used to preview TeX dvi files on X. 
If you install VFlib, you can use various fonts that can be used with
VFlib.  If you install Ghostscript, you can also view encapsulated
postscript (eps) files included in the dvi file.  The paths necessary
for this program are set with TeX's kpathsearch software.

If you feel the window menu is too large (or small), try xdvis (or xdvil).

%description -l ja
X  TeX  DVI եץӥ塼뤿Υեȥxdvik
ܸбǤǤ(ܸ첽ѥå xdvik-%{eversion}-%{jversion} )
VFlib Ѥ뤳Ȥ, ζ, JG եȷ, TrueType 
ܸ٥եȤɽ뤳ȤǤޤ. Ghostscript Ѥ 
EPS οޤޤ DVI եɽ뤳ȤǤޤ. ƼΥѥ
ˤ TeX kpathsearch Ѥޤ. 

̥ˤ碌ơ˥塼ɽ礭Ѥޤ
(˥塼礭ϴĶѿ XFONTSIZE=small/normal ؤˤʤޤ)
ɽȤˤ xdvis 礭ɽȤ xdvil 
ߤƲ

%prep
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%setup -q -n xdvik-%{eversion}
%patch0 -p1
(cd texk/xdvik
%patch1 -p0
%ifnos darwin
%patch2 -p0
%else
%patch13 -p0 -b .macosx
%endif
)

#%{__cp_a} texk/xdvik texk/oxdvik
#%patch12 -p1

%ifos darwin
%patch14 -p1 -b .macosx
(cd config
cp /usr/share/libtool/{config.guess,config.sub,ltmain.sh} .
cd ../texk
cp /usr/share/libtool/{config.guess,config.sub,ltmain.sh} .
)
%endif


%build

%ifarch sparc
EXT_LIB="-lXext"
%endif

######### Build xdvi #############################
#(cd texk; libtoolize --copy --force)
#(cd kpathsea; libtoolize --copy --force)
#(cd gsftopk; libtoolize --copy --force)
#(cd xdvik; libtoolize --copy --force)
#libtoolize --copy --force

%ifnos darwin
CFLAGS="$RPM_OPT_FLAGS -DA4" ./configure \
	--prefix=\${DESTDIR}/usr/X11R6 \
	--bindir=\${DESTDIR}/usr/X11R6/bin \
	--enable-shared --with-dvifilter=dvips \
	--with-vfontmap --enable-bdpi=600 \
	--enable-xdviprint=\${DESTDIR}/usr/X11R6/bin/xdviprint \
	--enable-xdvietcdir=\${DESTDIR}/usr/share/texmf/xdvi \
	--enable-shrink=7  --enable-smallpanel \
	--with-x-toolkit=xaw3d --with-system-www
%else
CFLAGS="$RPM_OPT_FLAGS -DA4" ./configure \
	--prefix=\${DESTDIR}/usr/X11R6 \
	--bindir=\${DESTDIR}/usr/X11R6/bin \
	--enable-shared --with-dvifilter=dvips \
	--with-vfontmap --enable-bdpi=600 \
	--enable-xdviprint=\${DESTDIR}/usr/X11R6/bin/xdviprint \
	--enable-xdvietcdir=\${DESTDIR}/usr/share/texmf/xdvi \
	--enable-shrink=7  --enable-smallpanel \
	--with-x-toolkit=xaw3d --without-system-www
%endif

%ifos darwin
(cd texk/xdvik
sed -e 's;XDVERSION/\*\*/JPVERSION;XDVERSION JPVERSION;' \
        version.h > version.h.mod
mv version.h.mod version.h
)
(cd texk/oxdvik
sed -e 's;XDVERSION/\*\*/JPVERSION;XDVERSION JPVERSION;' \
        version.h > version.h.mod
mv version.h.mod version.h
)
%endif


make XCFLAGS='-DMFMODE=\"cx\"' texmf=%{texmf} x_ext_lib="$EXT_LIB"

######### Build oxdvi #############################
#(cd texk/oxdvik
#make XCFLAGS='-DMFMODE=\"cx\"' texmf=%{texmf} x_ext_lib="$EXT_LIB" 
#)
###################################################

%install
rm -rf %{buildroot}
# install xdvik
(cd texk/xdvik
make DESTDIR=${RPM_BUILD_ROOT} texmf=%{build_texmf} install
)

(cd ${RPM_BUILD_ROOT}/usr/X11R6/bin
ln -sf xdvi xdvis
ln -sf xdvi xdvil
ln -sf xdvi.bin xdvis.bin
)

mkdir -p %{build_texmf}/xdvi
%{__cp_a} texk/xdvik/texmf/*.map %{build_texmf}/xdvi

######### install oxdvi #############################
#(cd texk/oxdvik
#make DESTDIR=${RPM_BUILD_ROOT} install
#)
###################################################

install -d ${RPM_BUILD_ROOT}/usr/X11R6/lib/X11/app-defaults/
install -m 644 %{SOURCE1} ${RPM_BUILD_ROOT}/usr/X11R6/lib/X11/app-defaults/XDvi

# set up vfontmap
cat %{SOURCE2} >>${RPM_BUILD_ROOT}%{_prefix}/share/texmf/xdvi/vfontmap

# for 'texconfig init'
ln -sf /usr/X11R6/lib/X11/app-defaults/XDvi %{build_texmf}/xdvi/XDvi

#desktop things
mkdir -p $RPM_BUILD_ROOT/etc/X11/applnk/Graphics
cat > $RPM_BUILD_ROOT/etc/X11/applnk/Graphics/xdvi.desktop <<EOF
[Desktop Entry]
Name=XDvi
Comment=XDvi previewer
Exec=/usr/X11R6/bin/xdvi
Icon=gnome-word.png
Terminal=0
Type=Application
EOF

# for src-special with emacs
mkdir -p $RPM_BUILD_ROOT%{_prefix}/share/emacs/site-lisp/xdvi
%{__cp_a} texk/xdvik/xdvi-search.el $RPM_BUILD_ROOT%{_prefix}/share/emacs/site-lisp/xdvi/

# remove unwanted files
rm -f $RPM_BUILD_ROOT/usr/X11R6/bin/t1mapper
rm -f $RPM_BUILD_ROOT/usr/X11R6/man/man1/t1mapper.1

%post
%{exec_texhash}
if [ ! -f %{_usr}/lib/%{__kpslib} ]; then
   (cd %{_usr}/lib; ln -s libkpathsea.%{__soext} %{__kpslib})
fi
exit 0

%postun
if [ "$1" = 0 ]; then
    %{exec_texhash}
fi
if [ x`find %{_usr}/lib/%{__kpslib} -type l` != x ]; then
   rm %{_usr}/lib/%{__kpslib}
fi
exit 0

%clean
rm -rf %{buildroot}

%files
%{__defattr}
%doc CHANGES INSTALL README* TODO
%doc texk/xdvik/{ANNOUNCE,BUGS,CHANGES*,FAQ,README*}
%doc texk/xdvik/READMEs/
%config /etc/X11/applnk/Graphics/xdvi.desktop
# /usr/X11R6/bin/oxdvi
# /usr/X11R6/bin/oxdvi.bin
/usr/X11R6/bin/xdvi
/usr/X11R6/bin/xdviprint
/usr/X11R6/bin/xdvis
/usr/X11R6/bin/xdvil
/usr/X11R6/bin/xdvi.bin
/usr/X11R6/bin/xdvis.bin
/usr/X11R6/bin/xdvizilla
# /usr/X11R6/bin/t1mapper # in tetex
%config /usr/X11R6/lib/X11/app-defaults/XDvi
/usr/X11R6/man/man1/xdvi*
%dir %{texmf}/xdvi
%config %{texmf}/xdvi/vfontmap
%config %{texmf}/xdvi/*.cfg
%{texmf}/xdvi/*.map
%{texmf}/xdvi/xdvipaper*
%{texmf}/xdvi/XDvi
%{_prefix}/share/emacs/site-lisp/xdvi

%changelog
* Tue Jan 06 2004 Keisuke Fujii <keisuke.fujii@kek.jp>
- 1st build on MacOS X10.3

* Tue Apr 29 2003 Keisuke Fujii <keisuke.fujii@kek.jp>
- 1st build on MacOS X10.2

* Fri Apr 18 2003 Nobuyuki Tsuchimura <tutimura@nn.iij4u.or.jp> 22.40w_jp-0vl1
- updated to xdvik-22.40w-j1.17.

* Sat Feb 22 2003 Nobuyuki Tsuchimura <tutimura@nn.iij4u.or.jp> 22.40v_jp-0t3
- removed needless TX/PXfonts support.

* Tue Jan 28 2003 Nobuyuki Tsuchimura <tutimura@nn.iij4u.or.jp> 22.40u_jp-0t1
- updated to xdvik-22.40u-j1.12.
- added xdvizilla.

* Mon Dec  2 2002 Nobuyuki Tsuchimura <tutimura@nn.iij4u.or.jp> 22.40s_jp-0t1
- updated to xdvik-22.40s-j1.12.
- removed start-xdvi.

* Sat Sep 14 2002 Nobuyuki Tsuchimura <tutimura@nn.iij4u.or.jp> 22.40l_jp-0t2
- updated to xdvik-22.40l-j1.09.
- make only one binary. (-smallpanel option is enabled at executing time.)

* Thu Sep  5 2002 Nobuyuki Tsuchimura <tutimura@nn.iij4u.or.jp> 22.40l_jp-0t1
- updated to xdvik-22.40l-j1.08.

* Fri Aug 30 2002 Nobuyuki Tsuchimura <tutimura@nn.iij4u.or.jp> 22.40k_jp-0t6
- updated to xdvik-22.40k-j1.08.
- removed useless xdviprint.diff, dot.patch and xaw3d.patch.
  (already done in original.)

* Mon Aug 19 2002 Nobuyuki Tsuchimura <tutimura@nn.iij4u.or.jp> 22.40k_jp-0t4
- updated to xdvik-22.40k-j1.06.
- added TX/PXfonts support.

* Fri Aug  2 2002 Nobuyuki Tsuchimura <tutimura@nn.iij4u.or.jp> 22.40k_jp-0t3
- updated to xdvik-22.40k.
- added startxdvi, xdvi-search.el.

* Tue Apr 16 2002 KOBAYASHI R. Taizo <tkoba@vinelinux.org> 22.15_jp-16
- update vfontmap to use MORISAWA basic 5 fonts

* Mon Mar 25 2002 Jun Nishii <jun@vinelinux.org> 22.15_jp-15
- update vfontmap to use df* and lx*

* Sat Nov 17 2001 Nobuyuki Tsuchimura <tutimura@nn.iij4u.or.jp> 22.15_jp-14
- add /usr/share/texmf/xdvi/XDvi for 'texconfig init' command
- add BuildRequires Xaw3d-devel

* Wed Aug  1 2001 Jun Nishii <jun@vinelinux.org> 22.15_jp-13
- build for tetex
- added xaw3d patch and dot patch
- added oxdvi
- obsoletes wmconfig/xdvi
- provides tetex-xdvik
- remove render.ps which is in tetex

* Sat Nov 18 2000 Jun Nishii <jun@vinelinux.org>
- bug fix for Tategaki mode

* Wed Jul 26 2000 Daisuke SUZUKI <daisuke@linux.or.jp>
- libtoolize for alpha

* Wed Jul 19 2000 Jun Nishii <jun@vinelinux.org>
- 22.15_jp-9
- update japanese patch: xdvik-22.15-j1.04
- auto gzip man and strip bins

* Wed Mar  8 2000 Jun Nishii <jun@vinelinux.org>
- fix Exec path

* Fri Jan 21 2000 Jun Nishii <jun@vinelinux.org>
- rel.7
- enable automatic detection of tategaki format
- small bug fix in spec
- added entries for true type fonts, pop, lei, gyo,... in vfontmap
- config vfontmap

* Sun Jan  9 2000 Jun Nishii <jun@vinelinux.org>
- patch for special.c (xdvi-jp-ML) is merged.

* Fri Jan  7 2000 Jun Nishii <jun@vinelinux.org>
- fix vfontmap to use jis fontmetric

* Fri Oct 29 1999 Norihito Ohmori <ohmori@flatout.org>
- change group.

* Fri Oct 15 1999 Norihito Ohmori <ohmori@flatout.org>
- add support for wmconfig in for the xdvi package

* Thu Oct 14 1999 Norihito Ohmori <ohmori@flatout.org>
- update to xdvik-22.15-j1.03
- fix font generation waring [VineSeed-devel:00128]

* Sat Sep 18 1999 Jun Nishii <jun@flatout.org>
- add xdvil
- change menu size by XFONTSIZE

* Fri Jun 25 1999 Jun Nishii <jun@flatout.org>
- bug fix in gsftopk

* Mon Jun 21 1999 Jun Nishii <jun@flatout.org>
- added gsftopk

* Wed Apr 21 1999 Jun Nishii <jun@flatout.org>
- updated to 22.02

* Wed Feb 24 1999 Jun Nishii <jun@flatout.org>
- added Japanese Summary for Vine Linux

* Thu Dec 3 1998 Jun Nishii <jun@flatout.org>
- rename as xdvik-20c_jp from xdvik-20cj1.0p0d-4
- added resource
- enable smaller font for xdvis by fixing xdvi and resource setting
- move some files under /usr/X11R6 from /usr/

* Wed Nov 11 1998 Jun Nishii <jun@flatout.org>
- use VFlib-2.24

* Sun Nov 8 1998 Jun Nishii <jun@flatout.org>
- use libwww
- move to dvips as a default dvi converter

* Sun Oct 18 1998 Jun Nishii <jun@flatout.org>
- bug fix of search path of vfontmap

* Mon Oct 12 1998 Jun Nishii <jun@flatout.org>
- update to xdvik-j1.0p0d patch
- make menu box smaller for xdvis and modify the settings
  (xdvik.sxdvi.pje.diff)
- add dviselect from SeeTeX

* Wed Sep 23 1998 Jun Nishii <jun@flatout.org>
- release 4
- move to /usr from /usr/local

* Thu Jun  4 1998 Jun Nishii <jun@flatout.org>
- add xdvis

* Sat May 30 1998 Jun Nishii <jun@flatout.org>
- first release for PJE
